﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import org.osflash.thunderbolt.Logger;
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	import com.actionscriptfacile.ui.text.UITextField;

	
	// definit la couleur de fond -du swf
	//[SWF(backgroundColor="0xffffff")] 
	
	public class Main extends Sprite
	{


		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 *
		 * Ctrl + Shift + B : compilation avec Sublime Text 2
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Exemple Voiture");
			
			// activation du Debug avec ThunderBolt
			Logger.info("Exemple Voiture");
			
			var oClio:Voiture = new Voiture("verte", "Renault", "Citadine", 4, 3, ["fermeture centralisée", "vitres électriques"]);
			
			MonsterDebugger.trace(this, "Voiture : "+ oClio.getDetails() );// affiche les caractéristiques de la voiture
			oClio.nom = "Clio verte";// change son nom
			oClio.type = "décapotable";// setter
			oClio.changeCouleur("bleu");// change sa couleur
			oClio.ajoutOption("toit ouvrant");// ajoute une option
			MonsterDebugger.trace(this, "Voiture : "+ oClio.getDetails() );// affiche les caractéristiques de la voiture
			Logger.debug("Voiture : "+ oClio.getDetails());
			
			// création d'une autre instance, une autre voiture
			var oScenic:Voiture = new Voiture("blanche", "Renault", "Familiale", 5, 5, ["fermeture centralisée", "vitres électriques", "peinture métalisée"]);
			oScenic.nom = "Scénic blanc";
			MonsterDebugger.trace(this, "Voiture : "+ oScenic.getDetails() );// affiche les caractéristiques de la voiture
			Logger.info("Voiture : "+ oClio.getDetails());


			// ajout d'un texte informatif
			var oInfosText:UITextField = this.addText("Félicitations pour votre compilation\navec Sublime Text 2 !");
			oInfosText.x = 25;
			oInfosText.y = 131;
			this.addChild(oInfosText);
		}



		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("bold", true);
			oTxtField.changeFormat("size", 26);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}		


	}// fin de la classe

}// fin du package
